
	REM Demo for DEFFNDER basic utility routines
	REM by Derek Bolli (dbolli at bigpond.net.au)
    REM v1.4 2015-12-28 Fixed issue with string storage which caused crash on Spectrum 128K
#    REM v1.3 2015-12-27 Added binary and hex functions
#    REM v1.2 2015-12-23 Added bitwise AND, OR, XOR logical functions
#    REM v1.0 2015-08-12

#    CLEAR 32767: LOAD "" CODE 32768: REM Module loader code
#    CLEAR 40959: LOAD "" CODE 40960: REM Module loader code
    CLEAR 61439: LOAD "" CODE 61440: REM Module loader code

#    LET deffndernextcodeaddr = 32768: REM Address of first byte of free space in Code buffer (starts at $8029 32809)
#    LET deffnderloadmodule = 32770: REM Load the next module on the tape to the first free byte of Code Buffer (deffndernextcodeaddr)
#    LET deffndernextcodeaddr = 40960: REM Address of first byte of free space in Code buffer (starts at $A029 41001)
#    LET deffnderloadmodule = 40962: REM Load the next module on the tape to the first free byte of Code Buffer (deffndernextcodeaddr)
    LET deffndernextcodeaddr = 61440: REM Address of first byte of free space in Code buffer (starts at $F029 61481)
    LET deffnderloadmodule = 61442: REM Load the next module on the tape to the first free byte of Code Buffer (deffndernextcodeaddr)

    DEF FN h(v)=INT ( v / 256 )
	DEF FN l(v)=v-FN h(v)*256
	REM Hi byte and lo byte of 16 bit word value

#    DEF FN p$(n)=CHR$ ( n + 48 + ( 7 AND ( n > 9 ) ) )
#	REM Hex conversion 4 bit

	PAPER 1: INK 7: BORDER 1
	CLS

    LET band16 = USR deffnderloadmodule
    PRINT PAPER 2; INK 4; "Loaded band16 at address: "; band16
#   added :dbolli:20151222 11:37:25

    DEF FN a(a,b)=USR band16

    LET bor16 = USR deffnderloadmodule
    PRINT PAPER 2; INK 4; "Loaded bor16 at address: "; bor16
#   added :dbolli:20151222 11:55:21

    DEF FN r(a,b)=USR bor16

    LET bxor16 = USR deffnderloadmodule
    PRINT PAPER 2; INK 4; "Loaded bxor16 at address: "; bxor16
#   added :dbolli:20151222 12:03:56

    DEF FN x(a,b)=USR bxor16

    LET dispbin = USR deffnderloadmodule
    PRINT PAPER 2; INK 4; "Loaded dispbin at address: "; dispbin
#   added :dbolli:20151222 19:41:17

    DEF FN b$(b)="" AND USR dispbin

    LET disphex = USR deffnderloadmodule
    PRINT PAPER 2; INK 4; "Loaded disphex at address: "; disphex
#   added :dbolli:20151227 14:12:34

    DEF FN h$(n)="" AND USR disphex

    PRINT PAPER 3; INK 6; "8 Bit Bitwise Operator Test"

    LET value1 = 170: REM $AA
    LET value2 = 240: REM $F0

    PRINT "Value 1 = "; PAPER 7; INK 2; value1; " $"; FN h$( value1 ); " "; FN b$( value1 )
    PRINT "Value 2 = "; PAPER 7; INK 2; value2; " $"; FN h$( value2 ); " "; FN b$( value2 )
    LET ret1 = FN a( value1, value2 )
    PRINT "New bitwise AND 8 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret1; " $"; FN h$( ret1 ); " "; FN b$( ret1 )
    PRINT

    LET value3 = 170: REM $AA
    LET value4 = 15: REM $0F

    PRINT "Value 3 = "; PAPER 7; INK 2; value3; " $"; FN h$( value3 ); " "; FN b$( value3 )
    PRINT "Value 4 = "; PAPER 7; INK 2; TAB 11; value4; " $"; FN h$( value4 ); " "; FN b$( value4 )
    LET ret2 = FN r( value3, value4 )
    PRINT "New bitwise OR 8 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret2; " $"; FN h$( ret2 ); " "; FN b$( ret2 )
    PRINT

    PRINT "Value 1 = "; PAPER 7; INK 2; value1; " $"; FN h$( value1 ); " "; FN b$( value1 )
    PRINT "Value 4 = "; PAPER 7; INK 2; TAB 11; value4; " $"; FN h$( value4 ); " "; FN b$( value4 )
    LET ret3 = FN x( value1, value4 )
    PRINT "New bitwise XOR 8 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret2; " $"; FN h$( ret3 ); " "; FN b$( ret3 )
#    PRINT

    GO SUB @waitforkey

    PRINT PAPER 3; INK 6; "16 Bit Bitwise Operator Test": PRINT

    LET value1 = 43690: REM $AAAA
    LET value2 = 65287: REM $FF07

    PRINT "Value 1 = "; PAPER 7; INK 2; value1; " $"; FN h$( FN h(value1) ); FN h$( FN l(value1) );
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value1)); FN b$(FN l(value1))
    PRINT "Value 2 = "; PAPER 7; INK 2; value2; " $"; FN h$( FN h(value2) ); FN h$( FN l(value2) );
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value2)); FN b$(FN l(value2))
    LET ret1 = FN a( value1, value2 )
    PRINT "New bitwise AND 16 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret1; TAB 16; "$"; FN h$( FN h(ret1) ); FN h$( FN l(ret1) );
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(ret1)); FN b$(FN l(ret1))
    PRINT

    LET value3 = 43520: REM $AA00
    LET value4 = 65450: REM $FFAA

    PRINT "Value 3 = "; PAPER 7; INK 2; value3; " $"; FN h$(FN h(value3)); FN h$(FN l(value3))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value3)); FN b$(FN l(value3))
    PRINT "Value 4 = "; PAPER 7; INK 2; value4; " $"; FN h$(FN h(value4)); FN h$(FN l(value4))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value4)); FN b$(FN l(value4))
    LET ret2 = FN r( value3, value4 )
    PRINT "New bitwise OR 16 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret2; TAB 16; "$"; FN h$(FN h(ret2)); FN h$(FN l(ret2))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(ret2)); FN b$(FN l(ret2))
    PRINT

    GO SUB @waitforkey

    PRINT PAPER 3; INK 6; "16 Bit Bitwise Op. Test (Cont.)": PRINT

    PRINT "Value 1 = "; PAPER 7; INK 2; value1; " $"; FN h$(FN h(value1)); FN h$(FN l(value1))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value1)); FN b$(FN l(value1))
    PRINT "Value 4 = "; PAPER 7; INK 2; value4; " $"; FN h$(FN h(value4)); FN h$(FN l(value4))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(value4)); FN b$(FN l(value4))
    LET ret3 = FN x( value1, value4 )
    PRINT "New bitwise XOR 16 bit Value = "
    PRINT TAB 10; PAPER 7; INK 2; ret3; TAB 16; "$"; FN h$(FN h(ret3)); FN h$(FN l(ret3))
    PRINT TAB 16; PAPER 7; INK 2; FN b$(FN h(ret3)); FN b$(FN l(ret3))
    PRINT

#    GO SUB @waitforkey

	LET dpeek = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded dpeek at address: "; dpeek

	DEF FN d(a)=USR dpeek

	PRINT "Next module address: "; FN d( deffndernextcodeaddr )

	LET dpoke = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded dpoke at address: "; dpoke

	DEF FN p(a,n)=USR dpoke

#	PRINT "Next module address: "; FN d( deffndernextcodeaddr )

    PRINT PAPER 3; INK 6; "16 Bit Double PEEK Test"
    PRINT PAPER 3; INK 6; "16 Bit Double POKE Test": PRINT

	LET SPARE2 = 23728: REM SPARE2 System Variable
	LET vlu = 45678
	
	POKE SPARE2,128: POKE SPARE2+1,64
	PRINT
	PRINT "Old SPARE2 Value = "; PAPER 7; INK 2; FN d( SPARE2 )
	PRINT "Dpoke of SPARE2 with "; PAPER 7; INK 2; vlu
	RANDOMIZE FN p( SPARE2, vlu )
	PRINT "New SPARE2 Value = "; PAPER 7; INK 2; FN d( SPARE2 )

	GO SUB @waitforkey

	LET instr = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded instr at address: "; instr

	DEF FN i(h$,n$,p)=USR instr

    PRINT PAPER 3; INK 6; "String Instr Test": PRINT

	LET s$ = "In a village of La Mancha whose name I do not..."
	LET t$ = "Mancha"
	LET n$ = "Cervantes"
	
	PRINT
	PRINT "Position of": PRINT PAPER 7; INK 2; t$
	PRINT "in": PRINT PAPER 7; INK 2; s$
	PRINT "is at char "; PAPER 7; INK 2; FN i( s$, t$, 1 ): REM Should be 20
	PRINT
	PRINT "Position of": PRINT PAPER 7; INK 2; n$
	PRINT "in": PRINT PAPER 7; INK 2; s$
	PRINT "is at char "; PAPER 7; INK 2; FN i( s$, n$, 1 ): REM Should be 0 not found

	GO SUB @waitforkey

	LET instr1 = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded instr1 at address: "; instr1

	DEF FN s(h$,n$)=USR instr1

    PRINT PAPER 3; INK 6; "String Instr1 Test": PRINT

	PRINT
	PRINT "Position of ": PRINT PAPER 7; INK 2; t$
	PRINT "in": PRINT PAPER 7; INK 2; s$
	PRINT "is at char "; PAPER 7; INK 2; FN s( s$, t$ ): REM Should be 20
	PRINT
	PRINT "Position of": PRINT PAPER 7; INK 2; n$
	PRINT "in": PRINT PAPER 7; INK 2; s$
	PRINT "is at char "; PAPER 7; INK 2; FN s( s$, n$ ): REM Should be 0 not found

	GO SUB @waitforkey

	LET lookup16 = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded lookup16 at addr: "; lookup16

	DEF FN g(h$,k)=USR lookup16

    PRINT PAPER 3; INK 6; "Numeric Lookup16 Test": PRINT

	LET d$ = CHR$ 1 + CHR$ 64 + CHR$ 99 + CHR$ 10
	LET d$ = d$ + CHR$ 2 + CHR$ 64 + CHR$ 100 + CHR$ 10
	LET d$ = d$ + CHR$ 3 + CHR$ 64 + CHR$ 101 + CHR$ 10
	LET d$ = d$ + CHR$ 4 + CHR$ 64 + CHR$ 102 + CHR$ 10
	LET d$ = d$ + CHR$ 5 + CHR$ 64 + CHR$ 103 + CHR$ 10
	LET d$ = d$ + CHR$ 6 + CHR$ 64 + CHR$ 104 + CHR$ 10

	PRINT
	FOR i = 1 to LEN d$ STEP 4
		PRINT STR$ CODE d$(i); ","; STR$ CODE d$(i+1); " -> ";
		PRINT STR$ CODE d$(i+2); ","; STR$ CODE d$(i+3)
	NEXT I
	PRINT
	PRINT

	LET key = 64 * 256 + 2
	LET vlu = FN g( d$, key )
	
	PRINT "value for "; PAPER 7; INK 2; key; PAPER 1; INK 7; " ("; PAPER 7; INK 2; FN l( key ); ","; FN h( key ); PAPER 1; INK 7; ")"
	PRINT "is "; PAPER 7; INK 2; vlu; PAPER 1; INK 7; " ("; PAPER 7; INK 2; FN l( vlu ); ","; FN h( vlu ); PAPER 1; INK 7; ")"

	LET key = 64 * 256 + 5
	LET vlu = FN g( d$, key )

	PRINT
	PRINT "value for "; PAPER 7; INK 2; key; PAPER 1; INK 7; " ("; PAPER 7; INK 2; FN l( key ); ","; FN h( key ); PAPER 1; INK 7; ")"
	PRINT "is "; PAPER 7; INK 2; vlu; PAPER 1; INK 7; " ("; PAPER 7; INK 2; FN l( vlu ); ","; FN h( vlu ); PAPER 1; INK 7; ")"

	GO SUB @waitforkey

	LET lookup8 = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded lookup8 at address: "; lookup8

#	DEF FN f(h$,k)="" AND USR lookup8
	DEF FN f(h$,k)=USR lookup8

    PRINT PAPER 3; INK 6; "Numeric Lookup8 Test": PRINT

	LET d$ = "azbycxdw"
	LET s$ = "c"
	
	PRINT
	PRINT "d$ = "; d$
#	PRINT "key = "; s$

	LET key = CODE s$
	LET vlu = FN f( d$, key )
	
	PRINT
	PRINT "value for "; PAPER 7; INK 2; CHR$ key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; CHR$ vlu; PAPER 1; INK 7; "("; STR$ vlu; ")"

	LET key = CODE "b"
	LET vlu = FN f( d$, key )
	
	PRINT "value for "; PAPER 7; INK 2; CHR$ key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; CHR$ vlu; PAPER 1; INK 7; "("; STR$ vlu; ")"

	LET key = CODE "z"
	LET vlu = FN f( d$, key )
	
	PRINT "value for "; PAPER 7; INK 2; CHR$ key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; CHR$ vlu; PAPER 1; INK 7; "("; STR$ vlu; ")"

	LET d$ = CHR$ 100 + CHR$ 200 + CHR$ 101 + CHR$ 201 + CHR$ 102 + CHR$ 202 + CHR$ 103 + CHR$ 203

	PRINT
	PRINT "d$ = "
	FOR i = 1 to LEN d$ STEP 2
		PRINT STR$ CODE d$(i); " -> ";
		PRINT STR$ CODE d$(i+1)
	NEXT I

	LET key = 102
	LET vlu = FN f( d$, key )

	PRINT
	PRINT "value for "; PAPER 7; INK 2; key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; vlu
	
	LET key = 100
	LET vlu = FN f( d$, key )

	PRINT "value for "; PAPER 7; INK 2; key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; vlu
	
	LET key = 123
	LET vlu = FN f( d$, key )
	
	PRINT "value for "; PAPER 7; INK 2; key; PAPER 1; INK 7; " is "; PAPER 7; INK 2; vlu

	GO SUB @waitforkey

	LET peekcs = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded peekcs at address: "; peekcs

	DEF FN c$(a)="" AND USR peekcs

	LET peeko = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded peeko at address: "; peeko

	DEF FN o(a,o)=USR peeko

	LET peeks = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded peeks at address: "; peeks

	DEF FN s$(a,l)="" AND USR peeks

	LET pokeo = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded pokeo at address: "; pokeo

	LET pokes = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded pokes at address: "; pokes

	DEF FN k(a,s$)=USR pokes

    PRINT PAPER 3; INK 6; "String PEEKs and POKEs Test": PRINT

#	LET straddr = 23296: REM printer buffer on 48K, extra System Variables on 128K
    LET straddr = FN d( deffndernextcodeaddr ): REM Use code buffer as temp string storage
	LET t$ = "This is a rather long string"

	PRINT
	PRINT "Poking fixed length string"
	PRINT PAPER 7; INK 2; """"; t$; """"
	RANDOMIZE FN k( straddr + 1, t$ )
	
	PRINT
	PRINT "Retrieving string..."
	PRINT "Fixed: ": PRINT PAPER 7; INK 2; """"; FN s$( straddr + 1, LEN t$ ); """"
	PRINT
	PRINT "Setting length of c string"
	POKE straddr, LEN t$
	PRINT "Retrieving string..."
	PRINT "c String: ": PRINT PAPER 7; INK 2; """"; FN c$( straddr ); """"

	GO SUB @waitforkey

	LET fnstring = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded fnstring at addr: "; fnstring

	DEF FN f$(s$,n)="" AND USR fnstring

    PRINT PAPER 3; INK 6; "String STRING$ Test": PRINT

	PRINT
	PRINT "10 iterations of": PRINT """Hello There..."""
	PRINT
	PRINT PAPER 7; INK 2; FN f$( "Hello There..." + CHR$ 13, 10 )

	GO SUB @waitforkey

	LET term = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded term at address: "; term

	DEF FN b(h$,n$)=USR term

	LET termn = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded termn at address: "; termn

	DEF FN t$(h$,n)="" AND USR termn

    PRINT PAPER 3; INK 6; "String Term Lookup Test": PRINT

	LET d$ = CHR$ 0 +"data item 1" + CHR$ 14 + CHR$ 1
	LET d$ = d$ + CHR$ 0 +"data item 2" + CHR$ 14 + CHR$ 2
	LET d$ = d$ + CHR$ 0 +"data item 3" + CHR$ 14 + CHR$ 3
	LET d$ = d$ + CHR$ 0 +"data item 4" + CHR$ 14 + CHR$ 4
	LET d$ = d$ + CHR$ 0 +"data item 5" + CHR$ 14 + CHR$ 5
	LET d$ = d$ + CHR$ 0 +"data item 6" + CHR$ 14 + CHR$ 6

	PRINT
	FOR i = 1 to 6
	PRINT """"; FN t$( d$, i ); """ = index "; i
	NEXT i
	
	PRINT

	LET i$ = "data item 4"
	
	PRINT "Index of """; i$; """ is "; PAPER 7; INK 2; FN b( d$, CHR$ 0 + i$ + CHR$ 14 )

	LET item = 5

	PRINT "Item at index "; item; " is "; PAPER 7; INK 2; """"; FN t$( d$, item ); """"

	GO SUB @waitforkey

	LET trunc = USR deffnderloadmodule
	PRINT PAPER 2; INK 4; "Loaded trunc at address: "; trunc

	DEF FN r$(s$)="" AND USR trunc

    PRINT PAPER 3; INK 6; "String Trunc Test": PRINT

	LET t$ = t$ + "          "

	PRINT
	PRINT "Trailing:": PRINT PAPER 7; INK 2;""""; t$; """"
	PRINT
	PRINT "Truncating..."
	LET t$ = FN r$( t$ )
	PRINT
	PRINT "Truncated:": PRINT PAPER 7; INK 2; """"; t$; """"

	GO SUB @waitforkey

	CLEAR: GO TO 10: REM Loop endlessly
	
@waitforkey:
	PRINT '; PAPER 5; INK 2;"Press any key to continue..."
	PAUSE 0
	CLS
	RETURN
